/*---------------------------------------------------------------------------*/
/*        Copyright (c) 1996 LAL Orsay, UPS-IN2P3-CNRS (France).             */
/*                                                                           */
/* Redistribution and use in source and binary forms, with or without        */
/* modification, are permitted provided that the following conditions        */
/* are met:                                                                  */
/* 1. Redistributions of source code must retain the above copyright         */
/*    notice, this list of conditions and the following disclaimer.          */
/* 2. Redistributions in binary form must reproduce the above copyright      */
/*    notice, this list of conditions and the following disclaimer in the    */
/*    documentation and/or other materials provided with the distribution.   */
/* 3. All advertising materials mentioning features or use of this software  */
/*    must display the following acknowledgement:                            */
/*      This product includes software developed by the Computer Application */
/*      Development Group at LAL Orsay (Laboratoire de l'Accelerateur        */
/*      Linaire - UPS-IN2P3-CNRS).                                           */
/* 4. Neither the name of the Institute nor of the Laboratory may be used    */
/*    to endorse or promote products derived from this software without      */
/*    specific prior written permission.                                     */
/*                                                                           */
/* THIS SOFTWARE IS PROVIDED BY THE LAL AND CONTRIBUTORS ``AS IS'' AND       */
/* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE     */
/* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR        */
/* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE LAL OR CONTRIBUTORS BE      */
/* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR       */
/* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF      */
/* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS  */
/* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   */
/* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF    */
/* THE POSSIBILITY OF SUCH DAMAGE.                                           */
/*---------------------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>

#include <CmMessage.h>

CmMessageStatus IntHandler (CmMessage message, char* sender, char* serverName);
CmMessageStatus LongHandler (CmMessage message, char* sender, char* serverName);
CmMessageStatus FloatHandler (CmMessage message, char* sender, char* serverName);
CmMessageStatus DoubleHandler (CmMessage message, char* sender, char* serverName);

int main (int argc, char* argv[])
{
  fprintf (stderr,"Utilisation : wait for a message of type INT, LONG, SHORT, TEXT, CHAR, FLOAT DOUBLE\n");
  fprintf (stderr,"Server name is: test_type\n");


  if (!CmMessageOpenServer ("test_type"))
    {
      return (0);
    }

  CmMessageInstallHandler (IntHandler, "INT");
  CmMessageInstallHandler (LongHandler, "LONG");
  CmMessageInstallHandler (FloatHandler, "FLOAT");
  CmMessageInstallHandler (DoubleHandler, "DOUBLE");
  
  CmMessageWait ();

  exit (0);
}

/*-----------------------------------------------------------------------*/
CmMessageStatus IntHandler (CmMessage message, char* sender, char* serverName)
/*-----------------------------------------------------------------------*/
{
  int i = CmMessageGetInt (message);

  fprintf (stderr,"Received from %s: %d \n", sender, i);

  return (CmMessageOk);
}

/*-----------------------------------------------------------------------*/
CmMessageStatus LongHandler (CmMessage message, char* sender, char* serverName)
/*-----------------------------------------------------------------------*/
{
  long l = CmMessageGetLong (message);

  fprintf (stderr,"Received from %s: %ld \n", sender, l);

  return (CmMessageOk);
}

/*-----------------------------------------------------------------------*/
CmMessageStatus FloatHandler (CmMessage message, char* sender, char* serverName)
/*-----------------------------------------------------------------------*/
{
  float f = CmMessageGetFloat (message);

  fprintf (stderr,"Received from %s: %20.4f \n", sender, f);

  return (CmMessageOk);
}

/*-----------------------------------------------------------------------*/
CmMessageStatus DoubleHandler (CmMessage message, char* sender, char* serverName)
/*-----------------------------------------------------------------------*/
{
  double d = CmMessageGetDouble (message);

  fprintf (stderr,"Received from %s: %20.10g \n", sender, d);

  return (CmMessageOk);
}

